blob: 627af8a176430df015a80554d1b518f367b22c03 [file] [log] [blame]
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +02001#!/bin/sh
2#
3# link vmlinux
4#
5# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_INIT) and
6# $(KBUILD_VMLINUX_MAIN). Most are built-in.o files from top-level directories
7# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
8# Ordering when linking is important, and $(KBUILD_VMLINUX_INIT) must be first.
9#
10# vmlinux
11# ^
12# |
13# +-< $(KBUILD_VMLINUX_INIT)
14# | +--< init/version.o + more
15# |
16# +--< $(KBUILD_VMLINUX_MAIN)
17# | +--< drivers/built-in.o mm/built-in.o + more
18# |
19# +-< ${kallsymso} (see description in KALLSYMS section)
20#
21# vmlinux version (uname -v) cannot be updated during normal
22# descending-into-subdirs phase since we do not yet know if we need to
23# update vmlinux.
24# Therefore this step is delayed until just before final link of vmlinux.
25#
26# System.map is generated to document addresses of all kernel symbols
27
28# Error out on error
29set -e
30
31# Nice output in kbuild format
32# Will be supressed by "make -s"
33info()
34{
35 if [ "${quiet}" != "silent_" ]; then
36 printf " %-7s %s\n" ${1} ${2}
37 fi
38}
39
Stephen Rothwella5967db2016-08-24 22:29:19 +100040# Thin archive build here makes a final archive with
41# symbol table and indexes from vmlinux objects, which can be
42# used as input to linker.
43#
44# Traditional incremental style of link does not require this step
45#
46# built-in.o output file
47#
48archive_builtin()
49{
50 if [ -n "${CONFIG_THIN_ARCHIVES}" ]; then
51 info AR built-in.o
52 rm -f built-in.o;
53 ${AR} rcsT${KBUILD_ARFLAGS} built-in.o \
54 ${KBUILD_VMLINUX_INIT} \
55 ${KBUILD_VMLINUX_MAIN}
Sami Tolvanen475bdd72017-11-28 08:48:49 -080056
57 if [ -n "${CONFIG_LTO_CLANG}" ]; then
58 mv -f built-in.o built-in.o.tmp
59 ${LLVM_AR} rcsT${KBUILD_ARFLAGS} built-in.o $(${AR} t built-in.o.tmp)
60 rm -f built-in.o.tmp
61 fi
Stephen Rothwella5967db2016-08-24 22:29:19 +100062 fi
63}
64
Sami Tolvanen475bdd72017-11-28 08:48:49 -080065# If CONFIG_LTO_CLANG is selected, collect generated symbol versions into
66# .tmp_symversions
67modversions()
68{
69 if [ -z "${CONFIG_LTO_CLANG}" ]; then
70 return
71 fi
72
73 if [ -z "${CONFIG_MODVERSIONS}" ]; then
74 return
75 fi
76
77 rm -f .tmp_symversions
78
79 for a in built-in.o ${KBUILD_VMLINUX_LIBS}; do
80 for o in $(${AR} t $a); do
81 if [ -f ${o}.symversions ]; then
82 cat ${o}.symversions >> .tmp_symversions
83 fi
84 done
85 done
86
87 echo "-T .tmp_symversions"
88}
89
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020090# Link of vmlinux.o used for section mismatch analysis
91# ${1} output file
92modpost_link()
93{
Stephen Rothwella5967db2016-08-24 22:29:19 +100094 local objects
95
96 if [ -n "${CONFIG_THIN_ARCHIVES}" ]; then
97 objects="--whole-archive built-in.o"
98 else
99 objects="${KBUILD_VMLINUX_INIT} \
100 --start-group \
101 ${KBUILD_VMLINUX_MAIN} \
102 --end-group"
103 fi
Sami Tolvanen475bdd72017-11-28 08:48:49 -0800104
105 if [ -n "${CONFIG_LTO_CLANG}" ]; then
106 # This might take a while, so indicate that we're doing
107 # an LTO link
108 info LTO vmlinux.o
109 else
110 info LD vmlinux.o
111 fi
112
113 ${LD} ${LDFLAGS} -r -o ${1} $(modversions) ${objects}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200114}
115
Sami Tolvanen7bd125e2017-06-16 12:52:57 -0700116# If CONFIG_LTO_CLANG is selected, we postpone running recordmcount until
117# we have compiled LLVM IR to an object file.
118recordmcount()
119{
120 if [ -z "${CONFIG_LTO_CLANG}" ]; then
121 return
122 fi
123
124 if [ -n "${CONFIG_FTRACE_MCOUNT_RECORD}" ]; then
125 scripts/recordmcount ${RECORDMCOUNT_FLAGS} $*
126 fi
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200127}
128
129# Link of vmlinux
130# ${1} - optional extra .o files
131# ${2} - output file
132vmlinux_link()
133{
134 local lds="${objtree}/${KBUILD_LDS}"
Stephen Rothwella5967db2016-08-24 22:29:19 +1000135 local objects
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200136
137 if [ "${SRCARCH}" != "um" ]; then
Sami Tolvanen475bdd72017-11-28 08:48:49 -0800138 local ld=${LD}
139 local ldflags="${LDFLAGS} ${LDFLAGS_vmlinux}"
140
141 if [ -n "${LDFINAL_vmlinux}" ]; then
142 ld=${LDFINAL_vmlinux}
143 ldflags="${LDFLAGS_FINAL_vmlinux} ${LDFLAGS_vmlinux}"
144 fi
145
146 if [[ -n "${CONFIG_THIN_ARCHIVES}" && -z "${CONFIG_LTO_CLANG}" ]]; then
Stephen Rothwella5967db2016-08-24 22:29:19 +1000147 objects="--whole-archive built-in.o ${1}"
148 else
149 objects="${KBUILD_VMLINUX_INIT} \
150 --start-group \
151 ${KBUILD_VMLINUX_MAIN} \
152 --end-group \
153 ${1}"
154 fi
155
Sami Tolvanen475bdd72017-11-28 08:48:49 -0800156 ${ld} ${ldflags} -o ${2} -T ${lds} ${objects}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200157 else
Stephen Rothwella5967db2016-08-24 22:29:19 +1000158 if [ -n "${CONFIG_THIN_ARCHIVES}" ]; then
159 objects="-Wl,--whole-archive built-in.o ${1}"
160 else
161 objects="${KBUILD_VMLINUX_INIT} \
162 -Wl,--start-group \
163 ${KBUILD_VMLINUX_MAIN} \
164 -Wl,--end-group \
165 ${1}"
166 fi
167
168 ${CC} ${CFLAGS_vmlinux} -o ${2} \
169 -Wl,-T,${lds} \
170 ${objects} \
171 -lutil -lrt -lpthread
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200172 rm -f linux
173 fi
174}
175
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200176# Create ${2} .o file with all symbols from the ${1} object file
177kallsyms()
178{
179 info KSYM ${2}
180 local kallsymopt;
181
Rusty Russellb92021b2013-03-15 15:04:17 +1030182 if [ -n "${CONFIG_HAVE_UNDERSCORE_SYMBOL_PREFIX}" ]; then
183 kallsymopt="${kallsymopt} --symbol-prefix=_"
James Hogan6895f972012-09-06 22:11:25 +0100184 fi
185
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200186 if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
James Hogan6895f972012-09-06 22:11:25 +0100187 kallsymopt="${kallsymopt} --all-symbols"
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200188 fi
189
Ard Biesheuvel4d5d5662016-03-15 14:58:12 -0700190 if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
Rusty Russellc6bda7c2014-03-17 14:05:46 +1030191 kallsymopt="${kallsymopt} --absolute-percpu"
192 fi
193
Ard Biesheuvel2213e9a2016-03-15 14:58:19 -0700194 if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
195 kallsymopt="${kallsymopt} --base-relative"
196 fi
197
Sam Ravnborg00e6c28c2012-05-08 19:53:46 +0200198 local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
199 ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200200
Ard Biesheuvela0439342016-02-05 11:25:05 +0100201 local afile="`basename ${2} .o`.S"
202
203 ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${afile}
204 ${CC} ${aflags} -c -o ${2} ${afile}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200205}
206
Arun Menon12e1b342017-07-27 10:41:57 -0700207# Generates ${2} .o file with RTIC MP's from the ${1} object file (vmlinux)
208# ${3} the file name where the sizes of the RTIC MP structure are stored
209# just in case, save copy of the RTIC mp to ${4}
210# Note: RTIC_MPGEN has to be set if MPGen is available
211rtic_mp()
212{
213 # assume that RTIC_MP_O generation may fail
214 RTIC_MP_O=
215
Preeti Nagar421929c2019-03-18 10:25:15 +0530216 local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
217 ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
218
Arun Menon12e1b342017-07-27 10:41:57 -0700219 ${RTIC_MPGEN} --objcopy="${OBJCOPY}" --objdump="${OBJDUMP}" \
220 --binpath='' --vmlinux=${1} --config=${KCONFIG_CONFIG} && \
Preeti Nagar421929c2019-03-18 10:25:15 +0530221 cat rtic_mp.c | ${CC} ${aflags} -c -o ${2} -x c - && \
Arun Menon12e1b342017-07-27 10:41:57 -0700222 cp rtic_mp.c ${4} && \
223 ${NM} --print-size --size-sort ${2} > ${3} && \
Preeti Nagar421929c2019-03-18 10:25:15 +0530224 RTIC_MP_O=${2} || echo RTIC MP generation has failed
Arun Menon12e1b342017-07-27 10:41:57 -0700225 # NM - save generated variable sizes for verification
226 # RTIC_MP_O is our retval - great success if set to generated .o file
Preeti Nagar421929c2019-03-18 10:25:15 +0530227 # Echo statement above prints the error message in case any of the
228 # above RTIC MP generation commands fail and it ensures rtic mp failure
229 # does not cause kernel compilation to fail.
Arun Menon12e1b342017-07-27 10:41:57 -0700230}
231
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200232# Create map file with all symbols from ${1}
233# See mksymap for additional details
234mksysmap()
235{
236 ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
237}
238
Linus Torvalds1347a2ce2012-05-28 10:32:28 -0700239sortextable()
240{
241 ${objtree}/scripts/sortextable ${1}
242}
243
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200244# Delete output files in case of error
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200245cleanup()
246{
247 rm -f .old_version
248 rm -f .tmp_System.map
249 rm -f .tmp_kallsyms*
250 rm -f .tmp_version
Sami Tolvanen475bdd72017-11-28 08:48:49 -0800251 rm -f .tmp_symversions
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200252 rm -f .tmp_vmlinux*
Stephen Rothwella5967db2016-08-24 22:29:19 +1000253 rm -f built-in.o
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200254 rm -f System.map
255 rm -f vmlinux
256 rm -f vmlinux.o
Arun Menon12e1b342017-07-27 10:41:57 -0700257 rm -f .tmp_rtic_mp_sz*
258 rm -f rtic_mp.*
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200259}
260
Sylvain BERTRANDab160db2015-05-07 00:36:04 +0000261on_exit()
262{
263 if [ $? -ne 0 ]; then
264 cleanup
265 fi
266}
267trap on_exit EXIT
268
269on_signals()
270{
271 exit 1
272}
273trap on_signals HUP INT QUIT TERM
274
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200275#
276#
277# Use "make V=1" to debug this script
278case "${KBUILD_VERBOSE}" in
279*1*)
280 set -x
281 ;;
282esac
283
284if [ "$1" = "clean" ]; then
285 cleanup
286 exit 0
287fi
288
289# We need access to CONFIG_ symbols
Michal Marek423a8152013-02-25 13:47:53 +0100290case "${KCONFIG_CONFIG}" in
291*/*)
292 . "${KCONFIG_CONFIG}"
293 ;;
294*)
295 # Force using a file from the current directory
296 . "./${KCONFIG_CONFIG}"
297esac
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200298
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200299# Update version
300info GEN .version
301if [ ! -r .version ]; then
302 rm -f .version;
303 echo 1 >.version;
304else
305 mv .version .old_version;
306 expr 0$(cat .old_version) + 1 >.version;
307fi;
308
Sami Tolvanen475bdd72017-11-28 08:48:49 -0800309archive_builtin
310
311#link vmlinux.o
312modpost_link vmlinux.o
313
314# modpost vmlinux.o to check for section mismatches
315${MAKE} -f "${srctree}/scripts/Makefile.modpost" vmlinux.o
316
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200317# final build of init/
Emese Revfy6b90bd42016-05-24 00:09:38 +0200318${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init GCC_PLUGINS_CFLAGS="${GCC_PLUGINS_CFLAGS}"
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200319
Sami Tolvanen475bdd72017-11-28 08:48:49 -0800320if [ -n "${CONFIG_LTO_CLANG}" ]; then
321 # Re-use vmlinux.o, so we can avoid the slow LTO link step in
322 # vmlinux_link
323 KBUILD_VMLINUX_INIT=
324 KBUILD_VMLINUX_MAIN=vmlinux.o
Sami Tolvanen7bd125e2017-06-16 12:52:57 -0700325
326 # Call recordmcount if needed
327 recordmcount vmlinux.o
Sami Tolvanen475bdd72017-11-28 08:48:49 -0800328fi
329
Arun Menon12e1b342017-07-27 10:41:57 -0700330# Generate RTIC MP placeholder compile unit of the correct size
331# and add it to the list of link objects
332# this needs to be done before generating kallsyms
333if [ ! -z ${RTIC_MPGEN+x} ]; then
334 rtic_mp vmlinux.o rtic_mp.o .tmp_rtic_mp_sz1 .tmp_rtic_mp1.c
335 KBUILD_VMLINUX_MAIN+=" "
336 KBUILD_VMLINUX_MAIN+=$RTIC_MP_O
337fi
338
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200339kallsymso=""
340kallsyms_vmlinux=""
341if [ -n "${CONFIG_KALLSYMS}" ]; then
342
343 # kallsyms support
344 # Generate section listing all symbols and add it into vmlinux
345 # It's a three step process:
346 # 1) Link .tmp_vmlinux1 so it has all symbols and sections,
347 # but __kallsyms is empty.
348 # Running kallsyms on that gives us .tmp_kallsyms1.o with
349 # the right size
350 # 2) Link .tmp_vmlinux2 so it now has a __kallsyms section of
351 # the right size, but due to the added section, some
352 # addresses have shifted.
353 # From here, we generate a correct .tmp_kallsyms2.o
354 # 2a) We may use an extra pass as this has been necessary to
355 # woraround some alignment related bugs.
356 # KALLSYMS_EXTRA_PASS=1 is used to trigger this.
357 # 3) The correct ${kallsymso} is linked into the final vmlinux.
358 #
359 # a) Verify that the System.map from vmlinux matches the map from
360 # ${kallsymso}.
361
362 kallsymso=.tmp_kallsyms2.o
363 kallsyms_vmlinux=.tmp_vmlinux2
364
365 # step 1
366 vmlinux_link "" .tmp_vmlinux1
367 kallsyms .tmp_vmlinux1 .tmp_kallsyms1.o
368
369 # step 2
370 vmlinux_link .tmp_kallsyms1.o .tmp_vmlinux2
371 kallsyms .tmp_vmlinux2 .tmp_kallsyms2.o
372
373 # step 2a
374 if [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
375 kallsymso=.tmp_kallsyms3.o
376 kallsyms_vmlinux=.tmp_vmlinux3
377
378 vmlinux_link .tmp_kallsyms2.o .tmp_vmlinux3
379
380 kallsyms .tmp_vmlinux3 .tmp_kallsyms3.o
381 fi
382fi
383
Arun Menon12e1b342017-07-27 10:41:57 -0700384# Update RTIC MP object by replacing the place holder
385# with actual MP data of the same size
386# Also double check that object size did not change
Preeti Nagar421929c2019-03-18 10:25:15 +0530387# Note: Check initilally if RTIC_MP_O is not empty or uninitialized,
388# as incase RTIC_MPGEN is set and failure occurs in RTIC_MP_O
389# generation, below check for comparing object sizes fails
390# due to an empty RTIC_MP_O object.
391if [ ! -z ${RTIC_MP_O} ]; then
Arun Menon12e1b342017-07-27 10:41:57 -0700392 rtic_mp "${kallsyms_vmlinux}" rtic_mp.o .tmp_rtic_mp_sz2 \
393 .tmp_rtic_mp2.c
394 if ! cmp -s .tmp_rtic_mp_sz1 .tmp_rtic_mp_sz2; then
395 echo >&2 'ERROR: RTIC MP object files size mismatch'
396 exit 1
397 fi
398fi
399
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200400info LD vmlinux
401vmlinux_link "${kallsymso}" vmlinux
402
Linus Torvalds1347a2ce2012-05-28 10:32:28 -0700403if [ -n "${CONFIG_BUILDTIME_EXTABLE_SORT}" ]; then
404 info SORTEX vmlinux
405 sortextable vmlinux
406fi
407
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200408info SYSMAP System.map
409mksysmap vmlinux System.map
410
411# step a (see comment above)
412if [ -n "${CONFIG_KALLSYMS}" ]; then
413 mksysmap ${kallsyms_vmlinux} .tmp_System.map
414
415 if ! cmp -s System.map .tmp_System.map; then
Michal Marek5369f552012-07-07 23:04:40 +0200416 echo >&2 Inconsistent kallsyms data
Michal Marek367e43c2012-08-10 11:55:11 +0200417 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200418 exit 1
419 fi
420fi
421
422# We made a new kernel - delete old version file
423rm -f .old_version